//******************************************
//
//  Title:  Venus the Fly Trap
//
//  Genre:  Platform
//
//  Coder:  Sephiroth (Dave Burford)
//
//  GFX:    Original GFX by Berni.
//          New GFX (div compatiable) by
//          Sephiroth (Dave Burford)
//
//  Notes:  My entry for the competition.
//
//******************************************


program venus;

CONST

    x_tiles=226;        //Map Width
    y_tiles=20;         //Map Height

    grav=8;             //Gravity Level
    max_jump=128;       //Max height of a jump (in pixels)

    screen_width=1024;
    half_width=512;

GLOBAL

    struct map_x[x_tiles]   //Tile Array
        map_y[20];
    end

    c_bg=501;               //Background to be used for current level

    struct data_x[x_tiles]  //Data Array (collisions, start points, badguys, ect)
        data_y[20];
    end

    kill_all=0;
    filet;          //file holding tiles
    fileg;          //file hold gui gfx
    sprites;        //file holding sprites
    power;
    s1=0;
    s2=0;
    s3=0;
    s4=0;
    s5=0;
    s6=0;
    s7=0;
    game;
    game2;

    p1h=5;
    _scroll=0;      //Scroll Pointer
    c_level=1;      //Level number

    c_player=1;     //Current Player

    lifes=2;        //Players Lifes
    start_x;        //Starting X location of a map
    start_y;        //Same as above but Y location

    px;             //Player X
    _offset;        //Map Offset (for pixel perfect scrolling)

    dbug=0;         //Debug mode on/off
    tracer_x;       //Real world total x position
    tracer_y;       //Same as above, for Y

    tile_x;         //Players X location in tiles
    tile_y;         //Players Y location in tiles

    enemy_move;     //Used to scroll the badguys with the tiles

    can_fire=1;     //Can currently fire yes/no
    kill_bullet=0;  //Remove the bullet yes/no


BEGIN

//    set_fps(30,1);
    filet=load_fpg("venus/tiles.fpg");
    fileg=load_fpg("venus/v_gui.fpg");
    sprites=load_fpg("venus/plbg.fpg");
    power=load_fpg("venus/power.fpg");

    game=load_fnt("venus/game.fnt");
    game2=load_fnt("venus/game2.fnt");
    set_mode(m1024x768);

    load_level(c_level);
    frame;
end

//*********************************************************

PROCESS load_level(lev);

PRIVATE

        a; b;    //misc variables for parsing data

BEGIN
    let_me_alone();

    if (lev==1)
        load("venus/vmap01.ven",&map_x);   //load map tiles
        load("venus/vmap01.dat",&data_x);  //load map data
    end

    from a=0 to x_tiles;
        from b=0 to y_tiles;
            if (data_x[a].data_y[b] == 8)  //Search map data for the starting position of the player
                start_x=a*32;
                start_y=b*32;
            end
        end
    end


    game_prev();

end

//*********************************************************

PROCESS game_prev();

PRIVATE
    a;b;
    idles=0;
    cen=25;

BEGIN

    kill_all=0;
    timer[3]=0;
    file=sprites;
    x=460+cen;
    y=275;
    LOOP

        if (c_level==1)
            write(game,512,200,4,"THE FORBIDDEN FOREST");
            write(game,512,220,4,"AREA - 1");
            write(game,512+cen,275,0,"X");
            write_int(game,532+cen,275,0,&lifes);
            write(game,512,340,4,"GET READY");
            write(game,466,350,0,"PLAYER");
            write_int(game,551,350,0,&c_player);
        end



        if (idles==0)

            graph=10;    //idle gfx
            timer[2]=0;
            idles=1;
        end

        if (idles==1)
            if (timer[3]=<300);
                graph=10;
            else
                graph++;
            end

            if (graph=>33)// && graph=<33);
                if (timer[2]=<300)
                    graph=24;
                else
                    timer[2]=0;
                    timer[3]=0;
                    graph=10;
                end
            end

        end





        If (key(_space))

            if (dbug==1) _debug(); end;

            game_loop();
            player(start_x,start_y);
            info();
            ihealth();

            from a=0 to x_tiles;     //Search map data for badguy types and locations
                from b=0 to y_tiles;

                    if (data_x[a].data_y[b] == 100)
                        ladybird(a*32,b*32,1);  //ladybird type 1
                    end

                    if (data_x[a].data_y[b] == 101)
                        ladybird(a*32,b*32,2);  //ladybird type 2
                    end

                    if (data_x[a].data_y[b] == 102)
                        catip(a*32,b*32,1);     //catipiller type 1
                    end

                    if (data_x[a].data_y[b] == 103)
                        flytrap(a*32,b*32);
                    end
                end
            end


            draw_map();
            delete_text(all_text);
            break;
        end


        frame;
        delete_text(all_text);
    end
END

//*********************************************************

PROCESS game_loop();

BEGIN

    file=filet;
    x=512; y=384; z=1000;
    graph=1;

    LOOP
        if (kill_all==1); break; end;
        frame;
    end
END

//*********************************************************

PROCESS draw_map()

PRIVATE

    a;b;  //misc variables for parsing tiles


BEGIN
    file=filet;
    px=0;

    LOOP

        if (kill_all==1); break; end;
        _scroll=(px/32);//-16;
        _offset=px mod(32);



        if (_scroll =< 0) _scroll=0; end;
//        if (_scroll+34 => x_tiles) _scroll=x_tiles-34; end;
        if (_scroll => x_tiles-32) _scroll=x_tiles-32; end;


        map_put(filet,1,c_bg,512,384);
        from a=0 to 34;
            from b=0 to y_tiles;



                if (a+_scroll =< x_tiles)
                    if (map_x[a+_scroll].map_y[b] != 0)
                        map_put(filet,1,map_x[a+_scroll].map_y[b],a*32-_offset,(b*32));
                    end
                end
            end
        end
        frame;
    end
END

//*********************************************************

PROCESS player(px,py);

PRIVATE

    old_x;           //Players old x position (what the player would go back to if they hit a wall)
    old_y;           //Same as above, but with Y this time

//    tile_x;
//    tile_y;

    no_left=false;   //can move left yes/no
    no_right=false;  //can move right yes/no

    on_floor=false;  //walking on the floor yes/no

    jumping=false;   //in middle of jump yes/no
    jump=0;

    going_down=0;    //reached peak of jump and now falling yes/no
    fallen=false;    //finished falling yes/no
    free_fall;       //walked of the edge of a cliff yes/no

    temp_y;          //temporary holder for Y position

    _speed=8;        //Players speed

    check_left=1;    //modifier added to tile_x to get 1 tile left of player
    check_right=1;   //same as above but for right.  Is here because code is easier to read with two

    just_dont=0;     //For when the player just shouldnt be moving (ie - falling into a cliff from mid jump ^_^)

    idle=1;          //Is the player idle (IE - not doing anything)
    idles=0;         //Idle animation start (if the player has been idle long enough)

    was_left=0;      //The direction the player previously faced
    was_right=1;     //Same as above but for right

    jani=0;          //jump animation
    janis=1;         //jump animation start
    going_left=0;    //Currently going left
    going_right=1;   //Currently going right

    g_type=1;        //Gun type - which gun you have selected

    tl;
    tr;

    wanim=34;
    walking=0;

    on_edge=0;
    eanim=44;

    animturn=0;
    animturn2=0;
    tanim=2;
    tanim2=6;

    invinc=0;        //Invincibility (start of level, after hit or power up)
    health=4;        //Players Health
//    janif;           //jump animation finished
    jump_speed=8;

BEGIN
     timer[3]=0;
     timer[9]=0;
     file=sprites;
     graph=2;
     x=px;
     y=py;
     tracer_x=x;

     LOOP


        if (kill_all==1); break; end;
        p1h=health;
        //********************************************************************
        //The code below provides the flashing effect during the three seconds
        //of invunrability at the start of a level.
        //********************************************************************

        if (timer[9]=<100)

            invinc=1;
            if (going_left==1 && flags!=5)
                flags=5;
            else
                if (going_left==1)
                    flags=1;
                else
                    if (going_right==1 && flags!=4)
                        flags=4;
                    else
                        if (going_right==1)
                            flags=0;
                        end
                    end

                end
            end
        else
            invinc=0;
            if (timer[9]=<150)
                if (going_left==1)
                    flags=1;
                else
                    flags=0;
                end
            end
        end

        //********************************************************************

        tracer_y=y;

        if (dbug==1)
            write_int(0,355,60,0,&x);
            write_int(0,355,80,0,&tl);
            write_int(0,355,100,0,&tr);
        end

        if (tracer_x =< 0) tracer_x=0; end;

        tile_y=y/32;
        tile_x=tracer_x/32;
        tl=((tracer_x-32)/32);
        tr=((tracer_x+32)/32);
//        if (going_right==1) tile_x=(tracer_x+31)/32; end;
  //      if (going_left==1) tile_x=(tracer_x-32)/32; end;

        if (tile_x=<0) tile_x=0; end;
        if (tile_x-1 =< 0) check_left=0; else check_left=1; end;
        if (tile_x+1 => x_tiles) check_right=0; else check_right=1; end;



        if (not key(_left) && not key(_right) && not key(_up) && not key(_down) && not key(_space) && on_floor==1)
            idle=1;
            enemy_move=0;
        else
            timer[3]=0;
            idles=0;
            idle=0;
        end


        if (idle==1)
            if (idles==0)

                graph=10;    //idle gfx
                timer[2]=0;
                idles=1;
            end
            if (idles==1)
                if (timer[3]=<500);
                    graph=10;
                else
                    graph++;
                end

                if (graph=>33)// && graph=<33);
                    if (timer[2]=<500)
                        graph=24;
                    else
                        timer[2]=0;
                        timer[3]=0;
                        graph=10;
                    end
                end

            end
        end

        //firing

        if (key(_space) && can_fire==1)

            if (going_right==1)
                if (graph=>6 && graph=<9)
                    fire(x+35,y,g_type,1);
                else
                    fire(x+35,y+10,g_type,1);
                end
            end
            if (going_left==1)
                if (graph=>6 && graph=<9)
                    fire(x-35,y,g_type,2);
                else
                    fire(x-35,y+10,g_type,2);
                end
            end
        end


        //Moving left:

        if (key(_left) && data_x[tile_x-check_left].data_y[tile_y] != 7 && just_dont==0)
            going_left=1;
            going_right=0;
            wanim++;
            walking=1;
            if (was_right==1 && on_floor != 0)
                graph=3;
                animturn=1;



            end

            //All this monkey crap below is just to make him animate a turn in the air without being able to pause his jump a float (thats why the jump code is in the repeat statement)

            if (was_right==1 && on_floor == 0)
                graph=6;
                animturn2=1;
 /*
                repeat
                    graph++;
                    enemy_move=-_speed;
                    if (free_fall==0)
                        if (key(_up) && going_down==0)
                            jumping=true;
                            jump=jump+8;
                            y=y-8;

                            if (jump => max_jump)
                                going_down=1;
                            end

                            if (data_x[tile_x].data_y[tile_y-1] == 7)
                                going_down=1;
                            end
                        else
                            if (jump => 0)
                                going_down=1;
                            end
                        end
                    end

                    if (going_down==1)
                        jumping=false;
                        jump=jump-8;
                        y=y+8;

                        if (jump=<0)
                            jump=0;
                            going_down=0;
                        end
                    end

                    frame;

                until(graph=>9)
  */
          //      graph=6;
            end

            //*****************************


            if (on_floor!=0) graph=2; end;

            was_right=0;
            was_left=1;

            if (timer[9]=>300)
    //            flags=1;
            end

            if (_scroll => 0 && x => screen_width - half_width)
                x=x-_speed;
                tracer_x=tracer_x-_speed;
                enemy_move=0;
            else
                if (_scroll =< 0 && x =< screen_width - half_width)
                    x=x-_speed;
                    tracer_x=tracer_x-_speed;
                    enemy_move=0;
                else
                    px=px-_speed;
                    tracer_x=tracer_x-_speed;
                    enemy_move=-_speed;
                end
            end
        else
            if (data_x[tile_x-check_left].data_y[tile_y] == 7);
                enemy_move=0;

            end
        end






        //Moving right:

        if (key(_right) && data_x[tile_x+check_right].data_y[tile_y] != 7 && just_dont==0)
            going_right=1;
            going_left=0;
            wanim++;
            walking=1;

            if (was_left==1 && on_floor != 0)
                graph=3;
                animturn=1;

            end







            //Here we go again with the jump-turn animation stuff.

            if (was_left==1 && on_floor == 0)
                graph=6;
                animturn2=1;
/*
                repeat
                    graph++;
                    enemy_move=+_speed;
                    frame;


                    if (free_fall==0)
                        if (key(_up) && going_down==0)
                            jumping=true;
                            jump=jump+8;
                            y=y-8;

                            if (jump => max_jump)
                                going_down=1;
                            end

                            if (data_x[tile_x].data_y[tile_y-1] == 7)
                                going_down=1;
                            end
                        else
                            if (jump => 0)
                                going_down=1;
                            end
                        end
                    end

                    if (going_down==1)

                        jumping=false;
                        jump=jump-8;
                        y=y+8;

                        if (jump=<0)
                            jump=0;
                            going_down=0;
                        end
                    end

                until(graph=>9)
*/
                graph=6;

            end

            //*****************************

            if (on_floor!=0) graph=2; end;

            was_left=0;
            was_right=1;

            if (timer[9]=>300)
  //              flags=0;
            end

            if (_scroll =< x_tiles-32 && x =< screen_width - half_width)
                x=x+_speed;
                tracer_x=tracer_x+_speed;
                enemy_move=0;
            else
                if (_scroll => x_tiles-32 && x => screen_width - half_width)
                    x=x+_speed;
                    tracer_x=tracer_x+_speed;
                    enemy_move=0;
                else
                    px=px+_speed;
                    tracer_x=tracer_x+_speed;
                    enemy_move=_speed;
                end
            end
        else
            if (data_x[tile_x+check_right].data_y[tile_y] == 7);
                enemy_move=0;
            end

        end




        old_y=y;
        old_x=x;

        if (NOT jumping && going_down==0)
            y=y+grav;
        end

        if (x-_speed=<0)
            no_left=true;
        end




//**********************************
//     Jumping code
//**********************************

        if (free_fall==0)
            if (key(_up) && going_down==0)
                jumping=true;
                jump=jump+jump_speed;
                y=y-jump_speed;

                if (jump => max_jump)
                    going_down=1;
                end

                if (data_x[tile_x].data_y[tile_y-1] == 7)
                    going_down=1;
                end
            else
                if (jump => 0)
                    going_down=1;
                end
            end
        end


        if (going_down==1)


            jumping=false;
            jump=jump-jump_speed;
            y=y+jump_speed;

            if (jump=<0)
                jump=0;
                going_down=0;
            end
        end



//**********************************





        if (collision(TYPE ladybird) OR collision(TYPE catip) OR collision(TYPE flytrap) AND invinc==0)
            health=health-1;
            timer[9]=0;
        end

        if (health < 0)
            timer[9]=0;

            if (lifes > 0)
                lifes=lifes-1;
//                signal(TYPE
                clear_screen();
                //kill_all=1;
                load_level(c_level);
            else
                exit("GAME OVER! - Thanks for playing the beta!",0);
            end
        end









//**********************************
// Collision trapping whilst falling
//**********************************
/*x        if (going_down==1 OR free_fall==1)

            if (data_x[tile_x-check_left].data_y[tile_y]==7)
                just_dont=1;
            else
                if (data_x[tile_x+check_right].data_y[tile_y]==7)
                    just_dont=1;
                else
                    if (data_x[tile_x+check_right].data_y[tile_y+1]==7)
                        just_dont=1;
                    else
                        if (data_x[tile_x-check_left].data_y[tile_y+1]==7)
                            just_dont=1;
                        else
                            just_dont=0;
                        end
                    end
                end
            end
        end*/
//**********************************

        if (tile_x+1>x_tiles)
            exit("Well done, thanks for playing the beta!",0);
        end
//**********************************
// Here is code I added to bug fix
//**********************************

//Fix 1: Traps and stops the error that caused badguys to loose position
//       in the scroll whilst player free-fell to the left.

        if (tile_y+1>y_tiles)
            boom(x,y,0);
            health=-20;
            lifes=lifes-1;
            load_level(c_level);
            break;
        end

        if (data_x[tile_x].data_y[tile_y+1] != 7 && key(_left) && not jumping && going_down == 0 && data_x[tile_x-check_left].data_y[tile_y] != 7 && data_x[tile_x-check_left].data_y[tile_y+1] != 7 && not key(_up))
            enemy_move=-_speed;
        end



//**********************************

        if (data_x[tile_x].data_y[tile_y+1] == 7) //if the tile below you is solid

            on_floor=true;     //your on the floor
            free_fall=0;       //your havnt walked off a ledge (free falling is different from coming down from a jump)

            if (not jumping)
                y=old_y;     //if you wernt jumping then keep the player on the ground (counter acting the constant gravity)
            end

            if (jump=>32)
                going_down=1;
            end

        else                    //however, if the tile wasnt solid..
            on_floor=false;     //your not on the floor

            if (not jumping)    //and if you wernt jumping...
                free_fall=1;    //you just fell off a ledge
            end
        end

/*        if (tile_x-1 => 0)
            if (data_x[tile_x-1].data_y[tile_y] == 7)
                no_left=true;
                enemy_move=0;
            else
                no_left=false;
            end
        end

        if (tile_x+1 <= x_tiles)
            if (data_x[tile_x+1].data_y[tile_y] == 7)
                no_right=true;
                enemy_move=0;
            else
                no_right=false;
            end
        end
*/


//***********************************************
//         Main Graphics/Animation Block
//***********************************************

/*        if (going_left==1)
            flags=1;
        end

        if (going_right==1)
            flags=0;
        end
*/
        //Edge Animation Activator

        if (data_x[tl].data_y[tile_y+1]!=7 && data_x[tile_x].data_y[tile_y+1]==7 && going_right==1)

            on_edge=1;
            eanim++;
        else
            if (data_x[tr].data_y[tile_y+1]!=7 && data_x[tile_x].data_y[tile_y+1]==7 && going_left==1)
                on_edge=1;
                eanim++;
            else
                on_edge=0;
            end


        end





        //Walking Animation

        if (walking==1)
            graph=wanim;
//            wanim++;
        end

        if (not key(_left) && not key(_right))
            wanim=34;
            graph=2;
        end

        if (wanim=>43) wanim=34; end;


        //Edge Animation

        if (on_edge==1)
            graph=eanim;
        end

        if (eanim=>47)
            eanim=44;
        end

        //Jump GFX

        if (on_floor==0)
            graph=6;
        end

        //Turning Animation

        if (animturn==1)
            just_dont=1;
            tanim++;


            if (tanim=>5)
                if (was_left==1)
                    was_left=0;
                end

                if (was_right==1)
                    was_right=0;
                end

                tanim=2;
//                graph=2;
                just_dont=0;
                animturn=0;
            end
        end


        if (animturn==1)
            graph=tanim;
        end


        if (animturn2==1)
            just_dont=1;
            tanim2++;


            if (tanim2=>9)
                if (was_left==1)
                    was_left=0;
                end

                if (was_right==1)
                    was_right=0;
                end

                tanim2=6;
//                graph=2;
                just_dont=0;
                animturn2=0;
            end
        end


        if (animturn2==1)
            graph=tanim2;
        end


        if (timer[9]=>150 && key(_left) && just_dont==0)
            flags=1;
        end

        if (timer[9]=>150 && key(_right) && just_dont==0)
            flags=0;
        end

//***********************************************



        frame;
//        delete_text(all_text);
     end
END


//**********************************


PROCESS _debug();

private

test;

BEGIN
    file=fileg;
    x=0;
    y=0;

    graph=200;
    flags=4;

    loop
        if (kill_all==1); break; end;
        write(0,20,5,0,"DEBUG MODE ON!");
        write(0,20,20,0,"Player Tile_X= ");
        write(0,20,40,0,"Player Tile_Y= ");
        write(0,20,60,0,"Current Scroll Position= ");
        write(0,200,20,0,"Current Scroll Offset= ");
        write(0,200,40,0,"Player World X Position= ");
        write(0,200,60,0,"Player Screen X Position= ");
        write(0,380,20,0,"Enemy Move= ");
        write_int(0,170,60,0,&_scroll);
        write_int(0,350,40,0,&tracer_x);
        write_int(0,110,20,0,&tile_x);
        write_int(0,110,40,0,&tile_y);
        write_int(0,335,20,0,&_offset);
        write_int(0,450,20,0,&enemy_move);
        if (key(_control))
            if (key(_d))
                delete_text(all_text);
                graph=0;
                dbug=0;
                break;
            end
        end

        frame;
        delete_text(all_text);
    end
END

//**********************************

PROCESS Ladybird(bx,by,_type);

PRIVATE

    //Still jump type
    jump_wait;         //random time to wait before starting jump cycle when level starts.  Ensures all bugs dont jump at same time
    jump_peak=128;     //the highest point of her jump
    jump_now=0;        //tell her to jump
    jump_trace=0;      //trace how high she is
    going_down;        //see if shes coming down from a jump
    first_jump=1;      //is this her first jump

    //Arc jump type
    vx;                //used in circular calculation
    vy;                //same as above
    ang;               //the current angle of the arc
    going_left=1;      //jumping left or right
    jump_speed=6;      //how fast to jump
    health=4;
    hit1=1;
    hit2=1;

BEGIN

    file=sprites;

    x=bx-12;
    y=by-8;
    vx=bx-12;
    vy=by-8;

    graph=100;
    timer[0]=0;

    jump_wait=(rand(0,50));

    loop
       if (kill_all==1); break; end;

       if (collision(type fire) && hit1==1)
            kill_bullet=1;
            health=health-1;
            hit1=0;
       end;

       if (health<0)
            graph=0;
            boom(x+25,y+15,1);
            break;
       end

       if (collision(TYPE player))
           boom(x,y,1);
           break;
       end
       //Type 1 - Jumps up and down on the spot without moving

       if (_type==1)

           if (first_jump==1 && timer[0]=>jump_wait)
                jump_now=1;
                first_jump=0;
           end

           //Animate then jump
           if (jump_now==0 && going_down==0 && first_jump==0)
                graph++;
                if (graph>105) graph=100; jump_now=1; end;
           end

           //Jump
           if (jump_now==1)
                jump_trace=jump_trace+8;
                y=y-8;

                if (jump_trace => jump_peak OR data_x[(x/32)+_scroll].data_y[y/32]==1)
                    going_down=1;
                end
            end

            //Fall
            if (going_down==1)
                jump_now=0;
                jump_trace=jump_trace-8;
                y=y+8;

                if (jump_trace=<0)
                    jump_trace=0;
                    going_down=0;
                    timer[0]=0;
                end
            end


       end


       //Type 2 - Jumps in a half arc to the left and then backagain

       if (_type==2)
            graph=100;
            if (going_left==1)
                for(ang=0; ang=<180; ang+=jump_speed)
                    x=(get_distx((ang*1000),100)+vx-100);
                    y=(get_disty((ang*1000),100)+vy);
                    x=x-enemy_move;
                    vx=vx-enemy_move;


                    if (collision(type fire) && hit1==1)
                        kill_bullet=1;
                        health=health-1;
                        hit1=0;
                    end;

                    if (health<0)
                        graph=0;
                        boom(x+25,y+15,1);
                        break;
                    end

                    frame;
                end

                repeat
                    x=x-enemy_move;
                    vx=vx-enemy_move;
                    graph++;
                    frame;
                until(graph=>105);
                graph=100;
                going_left=0;
            end

            if (going_left==0)
                for(ang=180; ang=>0; ang-=jump_speed)
                    x=(get_distx((ang*1000),100)+vx-100);
                    y=(get_disty((ang*1000),100)+vy);
                    x=x-enemy_move;
                    vx=vx-enemy_move;


                    if (collision(type fire) && hit1==1)
                        kill_bullet=1;
                        health=health-1;
                        hit1=0;
                    end;

                    if (health<0)
                        graph=0;
                        boom(x+25,y+15,1);
                        break;
                    end

                    frame;
                end
                repeat
                    x=x-enemy_move;
                    vx=vx-enemy_move;
                    graph++;
                    frame;
                until(graph=>105);
                graph=100;
                going_left=1;
           end
       end

       if (not key(_right) && not key(_left)) enemy_move=0; end;
       x=x-enemy_move;
       vx=vx-enemy_move;
       hit1=1;
       frame;

    end
END

//**********************************

PROCESS catip(bx,by,_type);

PRIVATE
    going_left;  //for when he's going left
    going_right; //for when he's going right

    walk_dist=100; //how far to walk from point in pixels (middle to right and middle to left)
    walk_trace=0; //how much of the distance has been walked

    rand_dir;    //used to determin a random direction to start him in
    bspeed=6;    //how fast to walk

    wait_time; //how long to wait between changing direction (set below to a value between half a second to a second
    stopping=0; //has he stopped

    temp=-100;
    pause=0;

    health=2;

BEGIN

    file=sprites;
    x=bx;
    y=by;
    rand_dir=rand(0,1);
    wait_time=50+rand(0,50);


    if (rand_dir==0)
        going_left=1;
        going_right=0;
    else
        going_left=0;
        going_right=1;
    end

    if (_type==1) graph=106; end;

    LOOP

       if (collision(TYPE player))
           boom(x,y,1);
           break;
       end


       if (kill_all==1); break; end;

       if (_type==1)

           if (collision(type fire))
                kill_bullet=1;
                health=health-1;

           end;

           if (health<0)
                graph=0;
                boom(x+25,y+15,1);
                break;
           end


            if (going_right==1 && pause==0)
                graph=106;
                flags=0;
                x=x+bspeed;
                walk_trace=walk_trace+bspeed;

                if (walk_trace=>walk_dist && stopping==0)
                    timer[1]=0;
                    pause=1;
                    stopping=1;
                end

            end

            if (going_left==1 && pause==0)
                flags=1;
                graph=106;
                x=x-bspeed;
                walk_trace=walk_trace-bspeed;

                if (walk_trace=<temp && stopping==0)
                    timer[1]=0;
                    pause=1;
                    stopping=1;

                end
            end


            if (pause==1)
                if (timer[1]=>wait_time)
                    if (going_left==1)
                        repeat
                            x=x-enemy_move;
                            graph++;
                            frame;
                        until (graph=>110)
                        flags=0;
                        graph=106;

                        going_right=1;
                        going_left=0;
                        stopping=0;
                        pause=0;
                        timer[1]=0;

                    else
                        if (going_right==1)
                            repeat
                                x=x-enemy_move;
                                graph++;
                                frame;
                            until (graph=>110)
                            flags=1;
                            graph=106;

                            going_left=1;
                            going_right=0;
                            stopping=0;
                            pause=0;
                            timer[1]=0;

                        end
                    end
                end
            end



       end


       if (not key(_right) && not key(_left)) enemy_move=0; end;
       x=x-enemy_move;

       frame;
    end
END

//**********************************

PROCESS fire(fx,fy,_type,dir);

PRIVATE

    dist;
    fspeed=16;

BEGIN
    can_fire=0;
    if (_type==1)
        dist=200;
    end

    file=power;
    graph=_type;
    x=fx;
    y=fy;
    z=-512;
    if (dir==1)
        flags=0;
        REPEAT
            if (((x/32)+_scroll)=>x_tiles*32)
                break;
            end
            if (data_x[(x/32)+_scroll].data_y[(y/32)]==7)
                break;
            end
            x=x+fspeed;

            if (kill_bullet==1)
                kill_bullet=0;
                break;
            end

            frame;
        until(x=>fx+dist);
    end

    if (dir==2)
        flags=1;
        REPEAT
            if (((x/32)+_scroll)=<0)
                break;
            end

            if (data_x[(x/32)+_scroll].data_y[(y/32)]==7)
                break;
            end

            if (kill_bullet==1)
                kill_bullet=0;
                break;
            end

            x=x-fspeed;
            frame;
        until(x=<fx-dist);
    end

    graph=100;
    frame;

    can_fire=1;
    graph=0;
    frame;
END

//**********************************

PROCESS boom(x,y,pwr);


BEGIN

    file=power;
    graph=200;
    z=-512;

    REPEAT
        graph++;
        frame;
    UNTIL (graph=>206);

    if (pwr==1)
        _power(x,y-20);
    end

END

//**********************************

PROCESS _power(x,y);

PRIVATE

    fall_power=0;
    min_fall=-8;
    xt;
    yt;
    yt2;
    bounce=0;
    max_bounce=3;
    half_force;

    going_down=1;

BEGIN

    file=power;
    graph=50;
    z=-512;

    fall_power=10;

    LOOP

        if (kill_all==1); break; end;
        x=x-enemy_move;
        graph++;

        if (graph=>55)
            graph=50;
        end

        if (bounce=<max_bounce)
            y=y-fall_power;
        end

        fall_power=fall_power-grav;

        if (fall_power =< min_fall)
            fall_power=min_fall;
        end


        xt=((x/32)+_scroll);
        yt=(y/32);
        yt2=((y-14)/32);

        if (xt=<0) xt=0; end;
        if (xt=>x_tiles) xt=x_tiles; end;
        if (yt=<0) yt=0; end;
        if (yt=>y_tiles) yt=y_tiles; end;
        if (yt2=<0) yt2=0; end;
        if (yt2=>y_tiles) yt2=y_tiles; end;


        if (data_x[xt].data_y[yt2+1]==7)
            bounce=bounce+1;
            going_down=0;
            half_force=fall_power/2;
            fall_power=((fall_power-fall_power)-half_force);
        end


        if (collision(type fire))
            power_ups(x,y-20);
            graph=0;
            break;
        end



        frame;

    end
END

//**********************************

PROCESS power_ups(x,y)

PRIVATE

    fall_power=0;
    min_fall=-8;
    xt;
    yt;
    yt2;
    bounce=0;
    max_bounce=3;
    half_force;

    going_down=1;

    ptype;

BEGIN
    file=power;
    ptype=rand(56,57);

    graph=ptype;

    LOOP

        x=x-enemy_move;



        if (bounce=<max_bounce)
            y=y-fall_power;
        end

        fall_power=fall_power-grav;

        if (fall_power =< min_fall)
            fall_power=min_fall;
        end


        xt=((x/32)+_scroll);
        yt=(y/32);
        yt2=((y-8)/32);

        if (xt=<0) xt=0; end;
        if (xt=>x_tiles) xt=x_tiles; end;
        if (yt=<0) yt=0; end;
        if (yt=>y_tiles) yt=y_tiles; end;
        if (yt2=<0) yt2=0; end;
        if (yt2=>y_tiles) yt2=y_tiles; end;


        if (data_x[xt].data_y[yt2+1]==7)
            bounce=bounce+1;
            going_down=0;
            half_force=fall_power/2;
            fall_power=((fall_power-fall_power)-half_force);
        end



        if (collision(type player))
                s7=s7+1;
                graph=0;
                break;
        end


        frame;
    end
END
//**********************************

PROCESS flytrap(x,y)

PRIVATE

    health=6;
    frame_delay=0;

BEGIN

    file=sprites;
    graph=111;

    LOOP

       if (collision(TYPE player))
           boom(x,y,1);

           break;
       end

        if (kill_all==1); break; end;

        if (collision(type fire))
            kill_bullet=1;
            health=health-1;

        end


        if (health<0)
            graph=0;
            boom(x,y+15,1);
            break;
        end


        frame_delay++;

        if (frame_delay=>2)
            graph++;
            frame_delay=0;
        end

        if (graph=> 114)
            graph=111;
        end

        x=x-enemy_move;
        frame;
    end
END

//**********************************

PROCESS info();

PRIVATE

    nudger=22;


BEGIN

    x=0;
    y=0;
    file=fileg;
    graph=300;

    LOOP
        write_int(game2,215,-2,0,&c_player);
        write_int(game2,215+nudger,-2,0,&s1);
        write_int(game2,230+nudger,-2,0,&s2);
        write_int(game2,245+nudger,-2,0,&s2);
        write_int(game2,260+nudger,-2,0,&s2);
        write_int(game2,275+nudger,-2,0,&s2);
        write_int(game2,290+nudger,-2,0,&s2);
        write_int(game2,305+nudger,-2,0,&s2);
        write_int(game2,662,-2,0,&lifes);

        if (s7>9)
            s7=0;
            s6=s6+1;
        end

        if (s6>9)
            s6=0;
            s5=s5+1;
        end

        if (s5>9)
            s5=0;
            s4=s4+1;
        end

        if (s4>9)
            s4=0;
            s3=s3+1;
        end

        if (s3>9)
            s3=0;
            s2=s2+1;
        end

        if (s2>9)
            s2=0;
            s1=s1+1;
        end

        if (s1>9)
            s1=9;
        end

        frame;
        delete_text(all_text);
    end
END

//**********************************

PROCESS ihealth();

PRIVATE

BEGIN
    file=fileg;
    x=439;
    y=8;

    loop
        if (p1h=>4)
            graph=301;
        else
            if (p1h==3)
                graph=302;
            else
                if (p1h==2)
                    graph=303;
                else
                    if (p1h==1)
                        graph=304;
                    else
                        graph=0;
                    end
                end
             end
         end

         frame;
     end
END







